"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var object_hash_1 = __importDefault(require("object-hash"));
var TokenContainer_1 = __importDefault(require("./TokenContainer"));
var annotationContext_1 = __importDefault(require("../../context/annotationContext"));
var textMapHelpers_1 = require("../../helpers/textMapHelpers");
var TextLayer = function (_a) {
    var inView = _a.inView, shouldRender = _a.shouldRender, canvasInitialized = _a.canvasInitialized, textLayer = _a.textLayer, needsTokenization = _a.needsTokenization, pageNumber = _a.pageNumber;
    var tokenizer = (0, react_1.useContext)(annotationContext_1["default"]).tokenizer;
    if (!shouldRender) {
        return null;
    }
    if (inView && canvasInitialized && (textLayer === null || textLayer === void 0 ? void 0 : textLayer.length)) {
        var offset_1 = 0;
        return (react_1["default"].createElement(react_1["default"].Fragment, null, textLayer.map(function (textLayerItem) {
            var _a;
            if (!((_a = textLayerItem.text) === null || _a === void 0 ? void 0 : _a.replace(/\s/g, ''))) {
                return null;
            }
            var tokens = (0, textMapHelpers_1.tokenizeText)(textLayerItem.text, tokenizer, needsTokenization);
            if (!tokens) {
                return null;
            }
            var filteredTokenLength = tokens.filter(function (t) { return t !== ' '; }).length;
            offset_1 += filteredTokenLength;
            return (react_1["default"].createElement(TokenContainer_1["default"], { key: (0, object_hash_1["default"])(textLayerItem), textLayerItem: textLayerItem, tokens: tokens, offset: offset_1 - filteredTokenLength, pageNumber: pageNumber }));
        })));
    }
    return null;
};
exports["default"] = (0, react_1.memo)(TextLayer);
//# sourceMappingURL=TextLayer.js.map