"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
var react_1 = require("react");
// @ts-ignore
var PdfJs = __importStar(require("pdfjs-dist/build/pdf.min"));
// @ts-ignore
var PdfWorker = __importStar(require("pdfjs-dist/build/pdf.worker.entry"));
var baseHeaders = {
    Accept: 'application/pdf'
};
var usePDF = function (_a) {
    var url = _a.url, data = _a.data, httpHeaders = _a.httpHeaders;
    PdfJs.GlobalWorkerOptions.workerSrc = PdfWorker;
    var _b = (0, react_1.useState)(0), pages = _b[0], setPages = _b[1];
    var _c = (0, react_1.useState)(null), document = _c[0], setDocument = _c[1];
    var _d = (0, react_1.useState)(false), error = _d[0], setError = _d[1];
    (0, react_1.useEffect)(function () {
        setPages(0);
        setDocument(null);
        setError(true);
        var pdfParams = {
            url: url,
            httpHeaders: __assign(__assign({}, baseHeaders), httpHeaders)
        };
        PdfJs.getDocument(url ? pdfParams : data)
            .promise.then(function (pdf) {
            setPages(pdf.numPages);
            setDocument(pdf);
            setError(false);
        })["catch"](function () {
            setPages(0);
            setDocument(null);
            setError(true);
        });
    }, [url, data, httpHeaders]);
    var fetchPage = (0, react_1.useCallback)(function (index) {
        if (document) {
            return document.getPage(index);
        }
        return null;
    }, [document]);
    return { pages: pages, error: error, fetchPage: fetchPage };
};
exports["default"] = usePDF;
//# sourceMappingURL=usePDF.js.map