"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = require("react");
var tesseract_js_1 = require("tesseract.js");
var sortBy_1 = __importDefault(require("lodash/sortBy"));
var pdfHelpers_1 = require("../helpers/pdfHelpers");
var worker = (0, tesseract_js_1.createWorker)({
    logger: function (m) { return console.info(m); }
});
var useTesseract = function (scale, context) {
    var _a = (0, react_1.useState)(false), ocrLoading = _a[0], setOcrLoading = _a[1];
    var _b = (0, react_1.useState)(undefined), ocrError = _b[0], setOcrError = _b[1];
    var _c = (0, react_1.useState)(null), ocrResult = _c[0], setOcrResult = _c[1];
    (0, react_1.useEffect)(function () {
        if (ocrResult && ocrResult.baseScale !== scale) {
            var rescaledWords = ocrResult.ocrWords.map(function (word) {
                var coords = (0, pdfHelpers_1.recalculateBoundingBox)(word.coords, ocrResult.baseScale, scale);
                var fontSize = (0, pdfHelpers_1.calculateFontSize)(coords.width, coords.height, word.text);
                var transform = (0, pdfHelpers_1.calculateTransform)(coords.width, fontSize, word.fontFamily, word.text, context);
                return __assign(__assign({}, word), { coords: coords, fontSize: fontSize, transform: transform });
            });
            setOcrResult(__assign(__assign({}, ocrResult), { ocrWords: rescaledWords, baseScale: scale }));
        }
    }, [ocrResult, scale, context]);
    var doOCR = (0, react_1.useCallback)(function (language) {
        if (language === void 0) { language = 'eng'; }
        return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        setOcrLoading(true);
                        return [4 /*yield*/, worker.load()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, worker.loadLanguage(language)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, worker.initialize(language)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, worker.recognize(context.canvas).then(function (result) {
                                setOcrError(undefined);
                                setOcrLoading(false);
                                var unsortedResult = result.data.words.map(function (word) {
                                    var coords = (0, pdfHelpers_1.calculateRectangleProperties)(word.bbox);
                                    var fontSize = (0, pdfHelpers_1.calculateFontSize)(coords.width, coords.height, word.text);
                                    var fontFamily = word.font_name || 'sans-serif';
                                    var transform = (0, pdfHelpers_1.calculateTransform)(coords.width, fontSize, fontFamily, word.text, context);
                                    return {
                                        coords: coords,
                                        text: word.text,
                                        fontSize: fontSize,
                                        fontFamily: fontFamily,
                                        transform: transform
                                    };
                                });
                                setOcrResult({
                                    confidence: result.data.confidence,
                                    ocrWords: (0, sortBy_1["default"])(unsortedResult, ['coords.top', 'coords.left']),
                                    baseScale: scale
                                });
                            }, function (error) {
                                setOcrResult(null);
                                setOcrLoading(false);
                                setOcrError(error);
                            })];
                }
            });
        });
    }, [scale, context]);
    return { ocrResult: ocrResult, ocrError: ocrError, ocrLoading: ocrLoading, doOCR: doOCR };
};
exports["default"] = useTesseract;
//# sourceMappingURL=useTesseract.js.map